diff -uNr ntop-3.3.8/plugins/remotePlugin.c ntop-3.3.9/plugins/remotePlugin.c
--- ntop-3.3.8/plugins/remotePlugin.c	2007-05-17 22:26:46.000000000 +0200
+++ ntop-3.3.9/plugins/remotePlugin.c	2008-12-08 16:53:31.000000000 +0100
@@ -76,7 +76,7 @@
   while(myGlobals.ntopRunState < FLAG_NTOPSTATE_SHUTDOWN) {
     fd_set remoteMask;
     int rc, all_right = 1;
-    char buf[1500], rsp[1500];
+    char buf[1500] = { '\0' }, rsp[1500] = { '\0' };
 
     FD_ZERO(&remoteMask);
     FD_SET(sock, &remoteMask);
diff -uNr ntop-3.3.8/plugins/rrdPlugin.c ntop-3.3.9/plugins/rrdPlugin.c
--- ntop-3.3.8/plugins/rrdPlugin.c	2008-08-11 01:05:06.000000000 +0200
+++ ntop-3.3.9/plugins/rrdPlugin.c	2008-11-05 13:14:49.000000000 +0100
@@ -471,7 +471,7 @@
   if(cluster == NULL) {
     if(hasNetFlow
        && ((filterString == NULL) || strcasestr(filterString, "flow"))) {
-      for(i=0; i<=2; i++) {
+      for(i=1; i<=3; i++) {
 	sendString("<TR><TD align=left>");
 
 	safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf),
@@ -530,7 +530,7 @@
       if(strcmp(rsrcName, CONST_RRD_EXTENSION))
 	continue;
 
- #if 0
+#if 0
       if(sumCounter(rrdPath, dp->d_name, "FAILURES", startTime, endTime, &total, &average) >= 0)
 	numFailures += total;
 #endif
@@ -581,7 +581,6 @@
 	    }
 	  }
 
-
 	  if(do_show) {
 	    sendString("<TR><TD align=left>\n");
 
@@ -1020,9 +1019,10 @@
   path[0] = '\0';
 
   switch(graphId) {
-  case 0: rrds = (struct nameLabel*)rrd_summary_new_flows; label = "Flows"; title = "Newly Created Flows: Statistics"; break;
-  case 1: rrds = (struct nameLabel*)rrd_summary_new_nf_flows; label = "Flows"; title = "Newly Created Flows: Protocol Breakdown"; break;
-  case 2: rrds = (struct nameLabel*)rrd_summary_new_nf_flows_size; label = "Bytes"; title = "Newly Created Flows: Average Size"; break;
+  case 0: rrds = (struct nameLabel*)rrd_summary_traffic; label = "Bytes"; title = "Traffic Statistics"; break;
+  case 1: rrds = (struct nameLabel*)rrd_summary_new_flows; label = "Flows"; title = "Newly Created Flows: Statistics"; break;
+  case 2: rrds = (struct nameLabel*)rrd_summary_new_nf_flows; label = "Flows"; title = "Newly Created Flows: Protocol Breakdown"; break;
+  case 3: rrds = (struct nameLabel*)rrd_summary_new_nf_flows_size; label = "Bytes"; title = "Newly Created Flows: Average Size"; break;
   }
 
   /* Check if the output directory has been deleted in the meantime */
@@ -1105,22 +1105,26 @@
     the_time = atol(startTime); the_tm = localtime(&the_time);
     strftime(strbuf, sizeof(strbuf), "%Y-%m-%d %H:%M", the_tm); sendString(strbuf);
 
-    sendString("\">\n<INPUT type=\"image\" src=\"/calendar.gif\" alt=\"Start date selector\" border=\"0\" align=\"absmiddle\" onclick=\"return showCalendar('date1');\">\n");
+    sendString("\">\n<INPUT type=\"image\" src=\"/calendar.gif\" alt=\"Start date selector\" border=\"0\" align=\"absmiddle\" "
+	       "onclick=\"return showCalendar('date1');\">\n");
     sendString("&nbsp;<strong>To:</strong>\n<INPUT type=\"text\" name=\"date2\" id=\"date2\" size=\"16\" value=\"");
 
     the_time = atol(endTime); the_tm = localtime(&the_time);
     strftime(strbuf, sizeof(strbuf), "%Y-%m-%d %H:%M", the_tm); sendString(strbuf);
 
-    sendString("\">\n<INPUT type=\"image\" src=\"/calendar.gif\" alt=\"End date selector\" border=\"0\" align=\"absmiddle\" onclick=\"return showCalendar('date2');\">\n"
+    sendString("\">\n<INPUT type=\"image\" src=\"/calendar.gif\" alt=\"End date selector\" border=\"0\" align=\"absmiddle\" "
+	       "onclick=\"return showCalendar('date2');\">\n"
 	       "<INPUT type=\"submit\" value=\"Update Graph\">\n</FORM>\n</TD></TR></TBODY></TABLE>\n</p>\n");
 
     /* *************************************** */
 
     sendString("<SCRIPT type=\"text/javascript\" src=\"/zoom.js\"></SCRIPT>\n"
 	       "<DIV id=\"zoomBox\" style=\"position: absolute; visibility: visible; background-image: initial; background-repeat: initial; "
-	       "background-attachment: initial; background-position-x: initial; background-position-y: initial; background-color: orange; opacity: 0.5;\"></DIV>\n");
+	       "background-attachment: initial; background-position-x: initial; background-position-y: initial; background-color: orange; "
+	       "opacity: 0.5;\"></DIV>\n");
 
-    sendString("<DIV id=\"zoomSensitiveZone\" style=\"position:absolute; overflow:none; background-repeat: initial; background-attachment: initial;  "
+    sendString("<DIV id=\"zoomSensitiveZone\" style=\"position:absolute; overflow:none; background-repeat: initial; "
+	       "background-attachment: initial;  "
 	       "background-position-x: initial; background-position-y: initial; visibility:visible; cursor:crosshair; background:blue; "
 	       "filter:alpha(opacity=0); -moz-opacity:0; -khtml-opacity:0; opacity:0;\" oncontextmenu=\"return false\"></DIV>\n");
 
@@ -1205,65 +1209,66 @@
 #endif
 #endif
 
-    argv[argc++] = "--title";
-    argv[argc++] = title;
-
-	str = "interfaces/";
-	i = strlen(str);
-	if(!strncmp(rrdPath, str, i))
-		pathIdx = i;
-	else
-		pathIdx = 0;
+  argv[argc++] = "--title";
+  argv[argc++] = title;
 
-	for(i=0, entryId=0; rrds[i].name != NULL; i++) {
-		char metric_name[32];
+  str = "interfaces/";
+  i = strlen(str);
+  if(!strncmp(rrdPath, str, i))
+    pathIdx = i;
+  else
+    pathIdx = 0;
+    
+  for(i=0, entryId=0; rrds[i].name != NULL; i++) {
+    char metric_name[32];
 
-		if(!strcmp(rrds[i].name, "throughput")) {
+    if(!strcmp(rrds[i].name, "throughput")) {
 #ifdef WIN32
-			safe_snprintf(__FILE__, __LINE__, path, sizeof(path), "%s/%u/interfaces/%s/%s.rrd",
-				myGlobals.rrdVolatilePath, driveSerial, &rrdPath[pathIdx], rrds[i].name);
+      safe_snprintf(__FILE__, __LINE__, path, sizeof(path), "%s/%u/interfaces/%s/%s.rrd",
+		    myGlobals.rrdVolatilePath, driveSerial, &rrdPath[pathIdx], rrds[i].name);
 #else
-			safe_snprintf(__FILE__, __LINE__, path, sizeof(path), "%s/interfaces/%s/%s.rrd",
-				myGlobals.rrdVolatilePath, rrdPath, rrds[i].name);
+      safe_snprintf(__FILE__, __LINE__, path, sizeof(path), "%s/interfaces/%s/%s.rrd",
+		    myGlobals.rrdVolatilePath, rrdPath, rrds[i].name);
 #endif
-		} else
-			safe_snprintf(__FILE__, __LINE__, path, sizeof(path), "%s/interfaces/%s/%s.rrd",
-			myGlobals.rrdPath, &rrdPath[pathIdx], rrds[i].name);
-
-		revertSlashIfWIN32(path, 0);
+    } else
+      safe_snprintf(__FILE__, __LINE__, path, sizeof(path), "%s/interfaces/%s/%s.rrd",
+		    myGlobals.rrdPath, &rrdPath[pathIdx], rrds[i].name);
 
-		if(stat(path, &statbuf) == 0) {
-			// traceEvent(CONST_TRACE_WARNING,  "-- 3 --> (%s)", path);
-			revertDoubleColumnIfWIN32(path);
-			safe_snprintf(__FILE__, __LINE__, buf[entryId], MAX_BUF_LEN, "DEF:ctr%d=%s:counter:AVERAGE", entryId, path);
-		argv[argc++] = buf[entryId];
+    revertSlashIfWIN32(path, 0);
 
-		safe_snprintf(__FILE__, __LINE__, buf1[entryId], MAX_BUF_LEN, "%s:ctr%d%s:%s", entryId == 0 ? "AREA" : "STACK",
-			entryId, rrd_colors[entryId], spacer(rrds[i].label, tmpStr, sizeof(tmpStr), metric_name, sizeof(metric_name)));
-		argv[argc++] = buf1[entryId];
+    if(debug_rrd_graph) traceEvent(CONST_TRACE_WARNING,  "-- 3 --> (%s)", path);
 
-		safe_snprintf(__FILE__, __LINE__, buf2[entryId], MAX_BUF_LEN, "GPRINT:ctr%d%s", entryId, ":AVERAGE:Avg\\: %3.1lf%s\\t");
-		argv[argc++] = buf2[entryId];
+    if(stat(path, &statbuf) == 0) {
+      revertDoubleColumnIfWIN32(path);
+      safe_snprintf(__FILE__, __LINE__, buf[entryId], MAX_BUF_LEN, "DEF:ctr%d=%s:counter:AVERAGE", entryId, path);
+      argv[argc++] = buf[entryId];
 
-		safe_snprintf(__FILE__, __LINE__, buf3[entryId], MAX_BUF_LEN, "GPRINT:ctr%d%s", entryId, ":LAST:Last\\: %3.1lf%s\\n");
-		argv[argc++] = buf3[entryId];
+      safe_snprintf(__FILE__, __LINE__, buf1[entryId], MAX_BUF_LEN, "%s:ctr%d%s:%s", entryId == 0 ? "AREA" : "STACK",
+		    entryId, rrd_colors[entryId], spacer(rrds[i].label, tmpStr, sizeof(tmpStr), metric_name, sizeof(metric_name)));
+      argv[argc++] = buf1[entryId];
 
-		entryId++;
+      safe_snprintf(__FILE__, __LINE__, buf2[entryId], MAX_BUF_LEN, "GPRINT:ctr%d%s", entryId, ":AVERAGE:Avg\\: %3.1lf%s\\t");
+      argv[argc++] = buf2[entryId];
 
-	if(entryId >= MAX_NUM_ENTRIES) break;
+      safe_snprintf(__FILE__, __LINE__, buf3[entryId], MAX_BUF_LEN, "GPRINT:ctr%d%s", entryId, ":LAST:Last\\: %3.1lf%s\\n");
+      argv[argc++] = buf3[entryId];
 
-	if(entryId >= CONST_NUM_BAR_COLORS) {
-		if(colorWarn == 0) {
-			traceEvent(CONST_TRACE_WARNING, "RRD: Number of defined bar colors less than max entries. Some graph(s) truncated");
-			colorWarn = 1;
-		}
+      entryId++;
 
-		break;
+      if(entryId >= MAX_NUM_ENTRIES) break;
 
-				} else {
-			// traceEvent(CONST_TRACE_WARNING, "RRD: Unable to find file %s", path);
-		}
+      if(entryId >= CONST_NUM_BAR_COLORS) {
+	if(colorWarn == 0) {
+	  traceEvent(CONST_TRACE_WARNING, "RRD: Number of defined bar colors less than max entries. Some graph(s) truncated");
+	  colorWarn = 1;
 	}
+
+	break;
+
+      } else {
+	// traceEvent(CONST_TRACE_WARNING, "RRD: Unable to find file %s", path);
+      }
+    }
   }
 
   accessMutex(&rrdMutex, "rrd_graph");
@@ -1292,7 +1297,8 @@
     traceEventRRDebugARGV(3);
 
     if(++graphErrCount < 50) {
-      traceEvent(CONST_TRACE_ERROR, "RRD: rrd_graph() call failed, rc %d, %s", rc, rrd_get_error() ? rrd_get_error() : "");
+      traceEvent(CONST_TRACE_ERROR, "RRD: rrd_graph() call failed, rc %d, %s",
+		 rc, rrd_get_error() ? rrd_get_error() : "");
       traceEvent(CONST_TRACE_INFO, "RRD: Failing file in netflowSummary() is %s", path);
     }
 
@@ -4234,7 +4240,10 @@
 	dumpShortInterval = _dumpShortInterval;
 
 	for(devIdx=0; devIdx<myGlobals.numDevices; devIdx++) {
-	  if((myGlobals.device[devIdx].virtualDevice && (!myGlobals.device[devIdx].sflowGlobals))
+	  if((myGlobals.device[devIdx].virtualDevice 
+	      && (!myGlobals.device[devIdx].sflowGlobals)
+	      && (!myGlobals.device[devIdx].netflowGlobals)
+	      )
 	     || (!myGlobals.device[devIdx].activeDevice))
 	    continue;
 
@@ -5026,7 +5035,9 @@
     rrdTime =  time(NULL);
 
     for(devIdx=0; devIdx<myGlobals.numDevices; devIdx++) {
-      if((myGlobals.device[devIdx].virtualDevice && (!myGlobals.device[devIdx].sflowGlobals))
+      if((myGlobals.device[devIdx].virtualDevice 
+	  && (!myGlobals.device[devIdx].sflowGlobals)
+	  && (!myGlobals.device[devIdx].netflowGlobals))
 	 || (!myGlobals.device[devIdx].activeDevice))
 	continue;
 
@@ -5236,7 +5247,6 @@
 	  /* if we didn't get a domain name, bail out */
 	  if ((el->dnsDomainValue == NULL)
 	      || (el->dnsDomainValue[0] == '\0')
-	      || (el->ip2ccValue == NULL)
 	      || (el->hostResolvedName[0] == '\0')
 	      || broadcastHost(el)
 	      ) {
@@ -5261,7 +5271,7 @@
 	    memset(statsEntry, 0, sizeof(DomainStats));
 	    statsEntry->domainHost = el;
 	    stats[keyValue] = statsEntry;
-	    traceEventRRDebug(2, "[%d] %s/%s", numEntries, el->dnsDomainValue, el->ip2ccValue);
+	    traceEventRRDebug(2, "[%d] %s", numEntries, el->dnsDomainValue);
 	  }
 
 	  /* count this host's stats in the domain stats */
@@ -5370,7 +5380,9 @@
     if(dumpInterfaces) {
       for(devIdx=0; devIdx<myGlobals.numDevices; devIdx++) {
 
-	if((myGlobals.device[devIdx].virtualDevice && (!myGlobals.device[devIdx].sflowGlobals))
+	if((myGlobals.device[devIdx].virtualDevice 
+	    && (!myGlobals.device[devIdx].sflowGlobals)
+	    && (!myGlobals.device[devIdx].netflowGlobals))
 	   || (!myGlobals.device[devIdx].activeDevice))
 	  continue;
 
@@ -5390,7 +5402,7 @@
 	updateCounter(rrdPath, "ipLocalToLocalBytes",  myGlobals.device[devIdx].tcpGlobalTrafficStats.local.value +
 		      myGlobals.device[devIdx].udpGlobalTrafficStats.local.value +
 		      myGlobals.device[devIdx].icmpGlobalTrafficStats.local.value, 0);
-	updateCounter(rrdPath, "ipLocalToRemoteBytes",    myGlobals.device[devIdx].tcpGlobalTrafficStats.local2remote.value +
+	updateCounter(rrdPath, "ipLocalToRemoteBytes", myGlobals.device[devIdx].tcpGlobalTrafficStats.local2remote.value +
 		      myGlobals.device[devIdx].udpGlobalTrafficStats.local2remote.value +
 		      myGlobals.device[devIdx].icmpGlobalTrafficStats.local2remote.value, 0);
 	updateCounter(rrdPath, "ipRemoteToLocalBytes", myGlobals.device[devIdx].tcpGlobalTrafficStats.remote2local.value +
diff -uNr ntop-3.3.8/plugins/rrdPlugin.h ntop-3.3.9/plugins/rrdPlugin.h
--- ntop-3.3.8/plugins/rrdPlugin.h	2007-11-11 10:15:49.000000000 +0100
+++ ntop-3.3.9/plugins/rrdPlugin.h	2008-10-14 08:02:59.000000000 +0200
@@ -253,6 +253,12 @@
   char *name, *label;
 };
 
+static const struct nameLabel rrd_summary_traffic[] = { 
+  { "ifInOctets", "Ingress Traffic" },
+  { "ifOutOctets", "Egress Traffic" },
+  { NULL, NULL }
+};
+
 static const struct nameLabel rrd_summary_new_flows[] = { 
   { "NF_numFlows", "Total Flows" },
   { "NF_numDiscardedFlows", "Discarded Flows" },
diff -uNr ntop-3.3.8/prefs.c ntop-3.3.9/prefs.c
--- ntop-3.3.8/prefs.c	2008-10-02 12:54:15.000000000 +0200
+++ ntop-3.3.9/prefs.c	2008-12-07 11:20:48.000000000 +0100
@@ -307,6 +307,10 @@
 }
 
 /* ***************************************************** */
+/*	NOTE
+	In the function below do NOT free myGlobals.runningPref.*
+	as this value is used in myGlobals.savedPref.*
+*/
 
 /*
  * Parse the command line options
@@ -382,7 +386,6 @@
 #ifndef WIN32
       stringSanityCheck(optarg, "-i | --interface");
 #endif
-      if(myGlobals.runningPref.devices != NULL) free(myGlobals.runningPref.devices);
       myGlobals.runningPref.devices = strdup(optarg);
       break;
 
@@ -439,7 +442,6 @@
 #ifndef WIN32
     case 'u':
       stringSanityCheck(optarg, "-u | --user");
-      if(myGlobals.effectiveUserName != NULL) free(myGlobals.effectiveUserName);
       myGlobals.effectiveUserName = strdup(optarg);
       if(strOnlyDigits(optarg))
 	myGlobals.userId = atoi(optarg);
@@ -527,22 +529,17 @@
 
     case 'N':
       pathSanityCheck(optarg, "-N | --wwn-map");
-      if(myGlobals.runningPref.fcNSCacheFile != NULL)
-	   free(myGlobals.runningPref.fcNSCacheFile);
       myGlobals.runningPref.fcNSCacheFile = strdup (optarg);
       break;
 
     case 'O': /* pcap log path - Ola Lundqvist <opal@debian.org> */
       pathSanityCheck(optarg, "-O | --output-packet-path");
-      if(myGlobals.runningPref.pcapLogBasePath != NULL)
-	free(myGlobals.runningPref.pcapLogBasePath);
-      myGlobals.runningPref.pcapLogBasePath = strdup(optarg);
+       myGlobals.runningPref.pcapLogBasePath = strdup(optarg);
       break;
 
     case 'P':
       pathSanityCheck(optarg, "-P | --db-file-path");
-      if(myGlobals.dbPath != NULL)
-	free(myGlobals.dbPath);
+      if(myGlobals.dbPath != NULL) free(myGlobals.dbPath);
 
       if(optarg[strlen(optarg)-1] == '/') optarg[strlen(optarg)-1] = '\0';
       mkdir_p("dbPath", optarg, 0777);
@@ -551,8 +548,7 @@
 
     case 'Q': /* Spool Path (ntop's spool directory) */
       pathSanityCheck(optarg, "-Q | --spool-file-path" );
-      if(myGlobals.spoolPath != NULL)
-	free(myGlobals.spoolPath);
+      if(myGlobals.spoolPath != NULL) free(myGlobals.spoolPath);
       if(optarg[strlen(optarg)-1] == '/') optarg[strlen(optarg)-1] = '\0';
       mkdir_p("spoolPath", optarg, 0777);
       myGlobals.spoolPath = strdup(optarg);
@@ -671,15 +667,11 @@
 
     case 137:
       stringSanityCheck(optarg, "--p3pcp");
-      if(myGlobals.runningPref.P3Pcp != NULL)
-	free(myGlobals.runningPref.P3Pcp);
       myGlobals.runningPref.P3Pcp = strdup(optarg);
       break;
 
     case 138:
       uriSanityCheck(optarg, "--p3puri", FALSE);
-      if(myGlobals.runningPref.P3Puri != NULL)
-	free(myGlobals.runningPref.P3Puri);
       myGlobals.runningPref.P3Puri = strdup(optarg);
       break;
 
@@ -691,8 +683,6 @@
       FILE *fd;
 
       stringSanityCheck(optarg, "--instance");
-      if(myGlobals.runningPref.instance != NULL)
-        free(myGlobals.runningPref.instance);
       myGlobals.runningPref.instance = strdup(optarg);
 
       memset(&tmpStr, 0, sizeof(tmpStr));
@@ -1002,10 +992,10 @@
     if (*globalVar != NULL) {
       free (*globalVar);
       *globalVar = NULL;
-      if (savePref) {
-	delPrefsValue (key);
-      }
     }
+	
+	 *globalVar = strdup(value);
+     if (savePref) delPrefsValue (key);
   }
   else {
     if (savePref) {
diff -uNr ntop-3.3.8/protocols.c ntop-3.3.9/protocols.c
--- ntop-3.3.8/protocols.c	2007-07-15 23:09:16.000000000 +0200
+++ ntop-3.3.9/protocols.c	2008-11-05 13:14:49.000000000 +0100
@@ -169,8 +169,6 @@
 		realDstHost->dnsDomainValue = NULL;
                 if (realDstHost->dnsTLDValue != NULL) free(realDstHost->dnsTLDValue);
 		realDstHost->dnsTLDValue = NULL;
-		if (realDstHost->ip2ccValue != NULL) free(realDstHost->ip2ccValue);
-		realDstHost->ip2ccValue = NULL;
 		if(isBroadcastAddress(&realDstHost->hostIpAddress, NULL, NULL))
 		  FD_SET(FLAG_BROADCAST_HOST, &realDstHost->flags);
 		else
@@ -333,41 +331,59 @@
 #endif
 		  switch((int)bootProto.bp_vend[idx]) {
 		  case FLAG_DHCP_DISCOVER_MSG:
-		    incrementHostTrafficCounter(realDstHost, protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_DISCOVER_MSG], 1);
-		    incrementHostTrafficCounter(srcHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_DISCOVER_MSG], 1);
+		    incrementHostTrafficCounter(realDstHost, 
+						protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_DISCOVER_MSG], 1);
+		    incrementHostTrafficCounter(srcHost,
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_DISCOVER_MSG], 1);
 		    break;
 		  case FLAG_DHCP_OFFER_MSG:
-		    incrementHostTrafficCounter(realDstHost, protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_OFFER_MSG], 1);
-		    incrementHostTrafficCounter(srcHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_OFFER_MSG], 1);
+		    incrementHostTrafficCounter(realDstHost,
+						protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_OFFER_MSG], 1);
+		    incrementHostTrafficCounter(srcHost, 
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_OFFER_MSG], 1);
 		    break;
 		  case FLAG_DHCP_REQUEST_MSG:
-		    incrementHostTrafficCounter(realDstHost, protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_REQUEST_MSG], 1);
-		    incrementHostTrafficCounter(srcHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_REQUEST_MSG], 1);
+		    incrementHostTrafficCounter(realDstHost, 
+						protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_REQUEST_MSG], 1);
+		    incrementHostTrafficCounter(srcHost, 
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_REQUEST_MSG], 1);
 		    break;
 		  case FLAG_DHCP_DECLINE_MSG:
-		    incrementHostTrafficCounter(realDstHost, protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_DECLINE_MSG], 1);
-		    incrementHostTrafficCounter(srcHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_DECLINE_MSG], 1);
+		    incrementHostTrafficCounter(realDstHost,
+						protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_DECLINE_MSG], 1);
+		    incrementHostTrafficCounter(srcHost, 
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_DECLINE_MSG], 1);
 		    break;
 		  case FLAG_DHCP_ACK_MSG:
-		    incrementHostTrafficCounter(realDstHost, protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_ACK_MSG], 1);
-		    incrementHostTrafficCounter(srcHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_ACK_MSG], 1);
+		    incrementHostTrafficCounter(realDstHost, 
+						protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_ACK_MSG], 1);
+		    incrementHostTrafficCounter(srcHost, 
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_ACK_MSG], 1);
 		    break;
 		  case FLAG_DHCP_NACK_MSG:
-		    incrementHostTrafficCounter(realDstHost, protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_NACK_MSG], 1);
-		    incrementHostTrafficCounter(srcHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_NACK_MSG], 1);
+		    incrementHostTrafficCounter(realDstHost,
+						protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_NACK_MSG], 1);
+		    incrementHostTrafficCounter(srcHost, 
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_NACK_MSG], 1);
 		    break;
 		  case FLAG_DHCP_RELEASE_MSG:
-		    incrementHostTrafficCounter(realDstHost, protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_RELEASE_MSG], 1);
-		    incrementHostTrafficCounter(srcHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_RELEASE_MSG], 1);
+		    incrementHostTrafficCounter(realDstHost,
+						protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_RELEASE_MSG], 1);
+		    incrementHostTrafficCounter(srcHost,
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_RELEASE_MSG], 1);
 		    break;
 		  case FLAG_DHCP_INFORM_MSG:
-		    incrementHostTrafficCounter(realDstHost, protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_INFORM_MSG], 1);
-		    incrementHostTrafficCounter(srcHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_INFORM_MSG], 1);
+		    incrementHostTrafficCounter(realDstHost,
+						protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_INFORM_MSG], 1);
+		    incrementHostTrafficCounter(srcHost, 
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_INFORM_MSG], 1);
 		    break;
 		  case FLAG_DHCP_UNKNOWN_MSG:
 		  default:
-		    incrementHostTrafficCounter(realDstHost, protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_UNKNOWN_MSG], 1);
-		    incrementHostTrafficCounter(srcHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_UNKNOWN_MSG], 1);
+		    incrementHostTrafficCounter(realDstHost, 
+						protocolInfo->dhcpStats->dhcpMsgRcvd[FLAG_DHCP_UNKNOWN_MSG], 1);
+		    incrementHostTrafficCounter(srcHost, 
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_UNKNOWN_MSG], 1);
 		    break;
 		  }
 		  idx += len;
@@ -482,12 +498,9 @@
 	    }
 
 	    if(realClientHost != NULL) {
-	      if(realClientHost->protocolInfo == NULL) realClientHost->protocolInfo = calloc(1, sizeof(ProtocolInfo));
-
-	      if(realClientHost->protocolInfo->dhcpStats == NULL) {
-		realClientHost->protocolInfo->dhcpStats = (DHCPStats*)malloc(sizeof(DHCPStats));
-		memset(realClientHost->protocolInfo->dhcpStats, 0, sizeof(DHCPStats));
-	      }
+	      /* Fix below courtesy of Massimo Torquati <torquati@ntop.org> */
+	      allocHostTrafficCounterMemory(realClientHost, protocolInfo, sizeof(ProtocolInfo));
+	      allocHostTrafficCounterMemory(realClientHost, protocolInfo->dhcpStats, sizeof(DHCPStats));
 
 	      while(idx < 64 /* Length of the BOOTP vendor-specific area */) {
 		u_char optionId = bootProto.bp_vend[idx++];
@@ -519,32 +532,41 @@
 #endif
 		  switch((int)bootProto.bp_vend[idx]) {
 		  case FLAG_DHCP_DISCOVER_MSG:
-		    incrementHostTrafficCounter(realClientHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_DISCOVER_MSG], 1);
+		    incrementHostTrafficCounter(realClientHost,
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_DISCOVER_MSG], 1);
 		    break;
 		  case FLAG_DHCP_OFFER_MSG:
-		    incrementHostTrafficCounter(realClientHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_OFFER_MSG], 1);
+		    incrementHostTrafficCounter(realClientHost, 
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_OFFER_MSG], 1);
 		    break;
 		  case FLAG_DHCP_REQUEST_MSG:
-		    incrementHostTrafficCounter(realClientHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_REQUEST_MSG], 1);
+		    incrementHostTrafficCounter(realClientHost, 
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_REQUEST_MSG], 1);
 		    break;
 		  case FLAG_DHCP_DECLINE_MSG:
-		    incrementHostTrafficCounter(realClientHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_DECLINE_MSG], 1);
+		    incrementHostTrafficCounter(realClientHost, 
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_DECLINE_MSG], 1);
 		    break;
 		  case FLAG_DHCP_ACK_MSG:
-		    incrementHostTrafficCounter(realClientHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_ACK_MSG], 1);
+		    incrementHostTrafficCounter(realClientHost, 
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_ACK_MSG], 1);
 		    break;
 		  case FLAG_DHCP_NACK_MSG:
-		    incrementHostTrafficCounter(realClientHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_NACK_MSG], 1);
+		    incrementHostTrafficCounter(realClientHost, 
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_NACK_MSG], 1);
 		    break;
 		  case FLAG_DHCP_RELEASE_MSG:
-		    incrementHostTrafficCounter(realClientHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_RELEASE_MSG], 1);
+		    incrementHostTrafficCounter(realClientHost, 
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_RELEASE_MSG], 1);
 		    break;
 		  case FLAG_DHCP_INFORM_MSG:
-		    incrementHostTrafficCounter(realClientHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_INFORM_MSG], 1);
+		    incrementHostTrafficCounter(realClientHost,
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_INFORM_MSG], 1);
 		    break;
 		  case FLAG_DHCP_UNKNOWN_MSG:
 		  default:
-		    incrementHostTrafficCounter(realClientHost, protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_UNKNOWN_MSG], 1);
+		    incrementHostTrafficCounter(realClientHost, 
+						protocolInfo->dhcpStats->dhcpMsgSent[FLAG_DHCP_UNKNOWN_MSG], 1);
 		    break;
 		  }
 		  idx += len;
